// ignore_for_file: public_member_api_docs, sort_constructors_first
import 'package:flutter/material.dart';
import 'package:hovertab/src/widgets/extra_widgets.dart';

// ignore: must_be_immutable
class HoverTab extends StatefulWidget {
  Color backgroundColor;
  Color tabColor;
  Color iconBackground;
  bool sideButton;
  List<Widget> background;
  bool backbutton;
  int tabNumber;
  List<Widget> tabNames;
  List<Widget> insideTab;
  HoverTab({
    Key? key,
    required this.backgroundColor,
    required this.tabColor,
    required this.iconBackground,
    this.sideButton=false,
    this.backbutton = true,
    required this.background,
    required this.tabNumber,
    required this.tabNames,
    required this.insideTab,
  }) : super(key: key);


  @override
  State<HoverTab> createState() => _HoverTabState();
}

class _HoverTabState extends State<HoverTab> {
  TabController? _tabController;

  Color color = Colors.white;
  double bottomHeight = 70;



  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {


    return Scaffold(
      backgroundColor: Colors.transparent,
      body: DefaultTabController(
        length: widget.tabNumber,
        child: NestedScrollView(
            headerSliverBuilder:
                (BuildContext context, bool innerBoxIsScrolled) {
              return <Widget>[
                SliverAppBar(
                  title: Row(
                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                    children: [
                      widget.backbutton==true? GestureDetector(
                          onTap: () {
                            Navigator.pop(context);
                          },
                          child: IconWidget(
                              icons: Icons.arrow_back,
                              backgroundColor: widget.iconBackground
                                  .withOpacity(0.6))):Container(),
                      widget.sideButton==true?GestureDetector(
                          onTap: () {
                            Navigator.pop(context);
                          },
                          child: IconWidget(
                              icons: Icons.arrow_back,
                              backgroundColor: widget.iconBackground
                                  .withOpacity(0.6))):Container()
                    ],
                  ),
                  backgroundColor: widget.backgroundColor,
                  collapsedHeight: 80,
                  automaticallyImplyLeading: false,
                  expandedHeight: 300.0,
                  floating: false,
                  pinned: true,
                  flexibleSpace: FlexibleSpaceBar(
                      background: Stack(
                          alignment: Alignment.center,
                          children:widget.background
                      )),
                  bottom: PreferredSize(
                    preferredSize: const Size.fromHeight(20),
                    child: Card(
                      shadowColor: Colors.black,
                      child: TabBar(
                          onTap: (val) {

                          },
                          controller: _tabController,
                          unselectedLabelColor: Colors.black,
                          indicator: BoxDecoration(
                              color: widget.tabColor,
                              borderRadius: BorderRadius.circular(4)),
                          tabs: widget.tabNames
                      ),
                    ),
                  ),
                ),
              ];
            },
            body: Container(
              decoration: const BoxDecoration(
                color: Colors.white,
              ),
              child: TabBarView(
                  physics:const NeverScrollableScrollPhysics(),
                  children: widget.insideTab
              ),
            )),
      ),
    );
  }
}
